////////////////////////////////////////////////////////////////////////////////////////////
//  FUNCION QUE DESCOMPONE UN VALOR INT Y LO GUARDA EN LA POSICION INDICADA DE LA EEPROM  //
////////////////////////////////////////////////////////////////////////////////////////////

void descomponerValor(int valor1, int posMemo)
{
  int valor2 = 0;
  while (valor1 > 255)
  {
  valor1 = valor1 - 255;
  valor2++;
  }
EEPROM.write(posMemo, valor1);
EEPROM.write(posMemo+1, valor2);
}



///////////////////////////////////////////////////////////////////////////////////////////
//          FUNCION ENCARGADA DE GUARDAR EL VALOR DE LAS VARIABLES EN LA EEPROM          //
///////////////////////////////////////////////////////////////////////////////////////////

void writeConfig()
{
//EEPROM.write(addr, val);

if (manual)                 //Si modo manual activo, almacenamos 0xFF
EEPROM.write(10, 0xFF);
else
EEPROM.write(10, 0x00);

if (modoTermo)              //Si hay termo, almacenamos 0xFF
EEPROM.write(11, 0xFF);
else
EEPROM.write(11, 0x00);

if (activo1)                 //Si horario activo, almacenamos 0xFF
EEPROM.write(20, 0xFF);
else
EEPROM.write(20, 0x00);

if (activo2)                 //Si horario activo, almacenamos 0xFF
EEPROM.write(21, 0xFF);
else
EEPROM.write(21, 0x00);

if (activo3)                 //Si horario activo, almacenamos 0xFF
EEPROM.write(22, 0xFF);
else
EEPROM.write(22, 0x00);

if (activo4)                 //Si horario activo, almacenamos 0xFF
EEPROM.write(23, 0xFF);
else
EEPROM.write(23, 0x00);

EEPROM.write(24, tPrebarrido);
EEPROM.write(25, tPelletIniS);
EEPROM.write(26, tPelletManS);

descomponerValor(tVentiResis, 27);
descomponerValor(tResistencia, 29);
descomponerValor(tLimpFinal, 31);
descomponerValor(tPelletIntS, 33);
descomponerValor(tPausaMax, 35);

EEPROM.write(37, tPelletIntL);

EEPROM.write(38, tempBombaMax);
EEPROM.write(39, tempBombaMin);
EEPROM.write(40, tempCalderaMax);
EEPROM.write(41, tempCalderaMin);
EEPROM.write(42, tempCalderaError);
EEPROM.write(43, tempViviendaMax);
EEPROM.write(44, tempViviendaMin);
EEPROM.write(45, tempExterior);

if (ctrLlama)                 //Si control husillo carga por pulsos
EEPROM.write(46, 0xFF);
else
EEPROM.write(46, 0x00);

if (segLlama)                 //Si carga mantenimiento por intensidad llama
EEPROM.write(47, 0xFF);
else
EEPROM.write(47, 0x00);

EEPROM.write(50, horaIni1);
EEPROM.write(51, minutoIni1);
EEPROM.write(52, horaIni2);
EEPROM.write(53, minutoIni2);
EEPROM.write(54, horaIni3);
EEPROM.write(55, minutoIni3);
EEPROM.write(56, horaIni4);
EEPROM.write(57, minutoIni4);

EEPROM.write(58, horaFin1);
EEPROM.write(59, minutoFin1);
EEPROM.write(60, horaFin2);
EEPROM.write(61, minutoFin2);
EEPROM.write(62, horaFin3);
EEPROM.write(63, minutoFin3);
EEPROM.write(64, horaFin4);
EEPROM.write(65, minutoFin4);
}





///////////////////////////////////////////////////////////////////////////////////////////
//      FUNCION ENCARGADA DE INICIALIZAR LAS VARIABLES CON VALORES DE LA EEPROM          //
///////////////////////////////////////////////////////////////////////////////////////////

void readConfig()
{
//value = EEPROM.read(address);  
if (EEPROM.read(10)==0xFF)                 //Si modo manual activo, almacenamos 0xFF
manual = true;
else
manual = false;

if (EEPROM.read(11)==0xFF)                 //Si hay termo, almacenamos 0xFF
modoTermo = true;
else
modoTermo = false;

if (EEPROM.read(20)==0xFF)                 //Si valor = 0xFF, horario activo
activo1 = true;
else
activo1 = false;

if (EEPROM.read(21)==0xFF)                 //Si valor = 0xFF, horario activo
activo2 = true;
else
activo2 = false;

if (EEPROM.read(22)==0xFF)                 //Si valor = 0xFF, horario activo
activo3 = true;
else
activo3 = false;

if (EEPROM.read(23)==0xFF)                 //Si valor = 0xFF, horario activo
activo4 = true;
else
activo4 = false;


tPrebarrido = EEPROM.read(24);
tPelletIniS = EEPROM.read(25);
tPelletManS = EEPROM.read(26);

tVentiResis = EEPROM.read(28)*255 + EEPROM.read(27);
tResistencia = EEPROM.read(30)*255 + EEPROM.read(29);
tLimpFinal = EEPROM.read(32)*255 + EEPROM.read(31);
tPelletIntS = EEPROM.read(34)*255 + EEPROM.read(33);
tPausaMax = EEPROM.read(36)*255 + EEPROM.read(35);


tPelletIntL = EEPROM.read(37);
tempBombaMax = EEPROM.read(38);
tempBombaMin = EEPROM.read(39);
tempCalderaMax = EEPROM.read(40);
tempCalderaMin = EEPROM.read(41);
tempCalderaError = EEPROM.read(42);
tempViviendaMax = EEPROM.read(43);
tempViviendaMin = EEPROM.read(44);
tempExterior = EEPROM.read(45);

if (EEPROM.read(46)==0xFF)                 //Si modo manual activo, almacenamos 0xFF
ctrLlama = true;
else
ctrLlama = false;

if (EEPROM.read(47)==0xFF)                 //Si modo manual activo, almacenamos 0xFF
segLlama = true;
else
segLlama = false;

horaIni1 = EEPROM.read(50);
minutoIni1 = EEPROM.read(51);
horaIni2 = EEPROM.read(52);
minutoIni2 = EEPROM.read(53);
horaIni3 = EEPROM.read(54);
minutoIni3 = EEPROM.read(55);
horaIni4 = EEPROM.read(56);
minutoIni4 = EEPROM.read(57);

horaFin1 = EEPROM.read(58);
minutoFin1 = EEPROM.read(59);
horaFin2 = EEPROM.read(60);
minutoFin2 = EEPROM.read(61);
horaFin3 = EEPROM.read(62);
minutoFin3 = EEPROM.read(63);
horaFin4 = EEPROM.read(64);
minutoFin4 = EEPROM.read(65);

}


