const char string_0[] PROGMEM = "HORA RTC        ";
const char string_1[] PROGMEM = "MODOS FUNCION   ";
const char string_2[] PROGMEM = "HORARIOS        ";
const char string_3[] PROGMEM = "TIEMPOS ACTUADOR";
const char string_4[] PROGMEM = "TEMPERATURAS    ";
const char string_5[] PROGMEM = "TEST            ";
const char string_6[] PROGMEM = "SENSORES        ";
const char string_7[] PROGMEM = "GUARDAR Y SALIR ";
const char string_8[] PROGMEM = "SALIR           ";
const char string_9[] PROGMEM = "Guardando ...   ";
const char string_10[] PROGMEM = "Saliendo ...   ";
//Menu Modos
const char string_11[] PROGMEM = "MODO ON: ";
const char string_12[] PROGMEM = "Manual";
const char string_13[] PROGMEM = "Auto";
const char string_14[] PROGMEM = "TIE/LLAM: ";
const char string_15[] PROGMEM = "Llama";
const char string_16[] PROGMEM = "Tiempo";
const char string_17[] PROGMEM = "SEG LLAM: ";
const char string_18[] PROGMEM = "On";
const char string_19[] PROGMEM = "Off";
const char string_20[] PROGMEM = "> SALIR";
const char string_21[] PROGMEM = "";
//Menu Sensores
const char string_22[] PROGMEM = "VER T CAL > ";
const char string_23[] PROGMEM = "VER T EXT > ";
const char string_24[] PROGMEM = "VER T VIV > ";
const char string_25[] PROGMEM = "VER LLAMA > ";
//Menu Test
const char string_26[] PROGMEM = "RESISTE: ";
const char string_27[] PROGMEM = "ACT RES: ";
const char string_28[] PROGMEM = "HUSILLO: ";
const char string_29[] PROGMEM = "VENTILA: ";
const char string_30[] PROGMEM = "BOMBA A: ";
//Menu Temperaturas
const char string_31[] PROGMEM = "ARRAN BOM: ";
const char string_32[] PROGMEM = "PARAR BOM: ";
const char string_33[] PROGMEM = "ARRAN QUE: ";
const char string_34[] PROGMEM = "PARAR QUE: ";
const char string_35[] PROGMEM = "TEMP ERRO: ";
const char string_36[] PROGMEM = "ENCE VIVI: ";
const char string_37[] PROGMEM = "APAG VIVI: ";
const char string_38[] PROGMEM = " C";
//Tiempos Actuadores
const char string_39[] PROGMEM = "PREBARRI: ";
const char string_40[] PROGMEM = "RESISTEN: ";
const char string_41[] PROGMEM = "RET SOPL: ";
const char string_42[] PROGMEM = "PEL S IN: ";
const char string_43[] PROGMEM = "PEL S MA: ";
const char string_44[] PROGMEM = "PEL PERI: ";
const char string_45[] PROGMEM = "PEL LLAM: ";
const char string_46[] PROGMEM = "PAUS MAX: ";
const char string_47[] PROGMEM = "TIE LIMP: ";
const char string_48[] PROGMEM = " s";
const char string_49[] PROGMEM = " L"; 
//Otros
const char string_50[] PROGMEM = "TERMO: ";
const char string_51[] PROGMEM = "VER PULSA > ";



const char* const string_table[] PROGMEM = {string_0, string_1, string_2, string_3, string_4, string_5, string_6, string_7, string_8, string_9, string_10, 
string_11, string_12, string_13, string_14, string_15, string_16, string_17, string_18, string_19, string_20, string_21, string_22, string_23, string_24, string_25,
string_26, string_27, string_28, string_29, string_30, string_31, string_32, string_33, string_34, string_35, string_36, string_37, string_38, string_39, string_40, 
string_41, string_42, string_43, string_44, string_45, string_46, string_47, string_48, string_49, string_50, string_51};

char buffer[30];



//////////////////////////////////////////////////////////////////////////////////
//        FUNCION ENCARGADA DE ESCRIBIR LAS FUNCIONES DEL MENU
//        MARCA CON > LA FUNCION SELECCIONADA
//////////////////////////////////////////////////////////////////////////////////

void updateMenu(int pos)
{
      lcd.clear();          //Borramos el lcd
      lcd.setCursor(0,0);   //Nos colocamos en la primera línea, primer caracter
      lcd.print("> ");      //Pone indicador > a la funcion seleccionada 
      strcpy_P(buffer, (char*)pgm_read_word(&(string_table[pos])));
      lcd.print(buffer);
      if (pos < 8)
      {
      lcd.setCursor(0,1);   //Si hay mas funciones, imprime la siguiente
      strcpy_P(buffer, (char*)pgm_read_word(&(string_table[pos+1])));
      lcd.print(buffer); 
      }
}



//////////////////////////////////////////////////////////////////////////////////
//        FUNCION ENCARGADA DE ESCRIBIR EL TITULO DE LA FUNCION
//        SELECCIONADA
//////////////////////////////////////////////////////////////////////////////////

void updateTitulo(int pos)
{
  lcd.clear();
  strcpy_P(buffer, (char*)pgm_read_word(&(string_table[pos])));
  lcd.print(buffer);
}


//////////////////////////////////////////////////////////////////////////////////
//        FUNCION ENCARGADA DE ESCRIBIR LA OPCION SELECCIONADA
//////////////////////////////////////////////////////////////////////////////////

void updateOpcion(int pos1, int valor, int pos2)
{
  lcd.setCursor(0,1);       //Borra la segunda linea
  lcd.print("                ");
  lcd.setCursor(0,1);       //Coloca el puntero en el primer caracter de la segunda linea
  strcpy_P(buffer, (char*)pgm_read_word(&(string_table[pos1])));
  lcd.print(buffer);
  if (valor != -1)
  lcd.print (valor);
  strcpy_P(buffer, (char*)pgm_read_word(&(string_table[pos2])));
  lcd.print(buffer);
}



//////////////////////////////////////////////////////////////////////////////////
//        FUNCION ENCARGADA DE DEVOLVER UN VALOR SEGUN EL BOTON PULSADO
//        Devuelve char u (UP), char d (DOWN) o char s (SELECT)
//        Si devuelve char n, se ha pulsado un boton diferente o esta
//        fuera de los limites
//////////////////////////////////////////////////////////////////////////////////

char selectMenu (int limInf, int limSup, int posLista)
{
  char boton = 'n';
  delay(200);
  while((boton = read_LCD_buttons()) == -1);    //Espera hasta que se pulse un boton
      
  if (boton == 3 && posLista > limInf)          //Se ha pulsado UP
  boton = 'u';


  else if (boton == 4 && posLista < limSup)     //Se ha pulsado DOWN
  boton = 'd';
  

  else if (boton == 5)                          //Se ha pulsado SELECT
    {
    boton = 's';
    while (read_LCD_buttons() == 5);    //Espera hasta que el boton vuelva a reposo
    delay(100);
    }

  return boton;
}



/////////////////////////////////////////////////////////////////
//        FUNCION QUE PRESENTA HORARIOS Y ESTADO
/////////////////////////////////////////////////////////////////
//Funcion usada para presentar adecuadamente los valores

void MostrarHorarios(int h1, int m1, int h2, int m2, boolean activo)
{
  lcd.setCursor(10,0);
  activo ? lcd.print("- ON ") : lcd.print("- OFF");

  lcd.setCursor(0,1);
  lcd.print("                ");
  lcd.setCursor(0,1);
  lcd.print("I:");
  {
    if (h1 < 9)
    {
    lcd.print("0");
    lcd.print(h1);
    }
    else
    lcd.print(h1);
  }
  
  lcd.print(":");
  {
    if (m1 < 9)
    {
    lcd.print("0");
    lcd.print(m1);
    }
    else
    lcd.print(m1);
  }
  
  lcd.print(" F:");
  {
    if (h2 < 9)
    {
    lcd.print("0");
    lcd.print(h2);
    }
    else
    lcd.print(h2);
  }
  
  lcd.print(":");
  {
    if (m2 < 9)
    {
    lcd.print("0");
    lcd.print(m2);
    }
    else
    lcd.print(m2);
  }
  }



/////////////////////////////////////////////////////////////////
//        IMPRIMIR VARIABLE Y MODIFICAR VALOR ENTRE LIMITES
/////////////////////////////////////////////////////////////////
//Funcion usada para presentar la variable y los valores que puede tomar

int mostrarCambioValor(int maximo, int minimo, int lugar, int valor, String nombre)
{
boton = -1;
lcd.setCursor(0,1);
lcd.print("                ");
lcd.setCursor(0,1);
lcd.print(nombre);

while((boton = read_LCD_buttons()) != 5)    //Mientras no se pulsa select no salimos
    {
    if (boton == 3)   //Si se pulsa up, incrementamos valor hasta maximo
      {
      valor ++;
      if (valor > maximo)
      valor = minimo;
      }
      
    if (boton == 4)   //Si se pulsa down, decrementamos valor hasta minimo
      {
      valor --;
      if (valor < minimo)
      valor = maximo;
      }
      
      delay(150);
      lcd.setCursor(lugar, 1);    //Pone el cursor en el lugar indicado para escribir el valor con ceros a la izquierda
      if (valor < 1000 && maximo > 999)
      lcd.print("0");
      if (valor < 100 && maximo > 99)
      lcd.print("0");
      if (valor < 10)
      lcd.print("0");
      lcd.print(valor);
    }
    
    while((boton = read_LCD_buttons()) == 5)    //Esperamos hasta que se deje de pulsar sobre SELECT
    {
      delay(100);       
    }
    
    return valor;     //Devuelve el valor seleccionado
}



/////////////////////////////////////////////////////////////////
//        CAMBIAR ESTADO HORARIO: ACTIVA-APAGADA
/////////////////////////////////////////////////////////////////
//Funcion usada para activar o cancelar un horario

void activarAlarma (int alarma, boolean estado)
{
boton = -1;
lcd.setCursor(0,1);
lcd.print("                ");
lcd.setCursor(0,1);
if (estado)
lcd.print("ACTIVO");
else
lcd.print("APAGADO");
while((boton = read_LCD_buttons()) != 5)
{
  if (boton == 3 || boton == 4)
  {
  estado = !estado;
  
  lcd.setCursor(0,1);
  lcd.print("                ");
  lcd.setCursor(0,1);
  if (estado)
  lcd.print("ACTIVO");
  else
  lcd.print("APAGADO");
  delay(500);
  }
}

while((boton = read_LCD_buttons()) == 5)
  {
    delay(100);
  }

if (alarma == 0)
activo1 = estado;
if (alarma == 1)
activo2 = estado;
if (alarma == 2)
activo3 = estado;
if (alarma == 3)
activo4 = estado;
delay(500);
}






////////////////////////////////////////////////////
//    MENU CONFIGURACION
////////////////////////////////////////////////////
// HORA RTC
// MODOS FUNCION
// HORARIOS
// TIEMPOS ACTUADOR
// TEMPERATURAS
// TEST
// SENSORES
// GUARDAR Y SALIR
// SALIR
////////////////////////////////////////////////////



////////////////////////////////////////////////////
//            FUNCION PRINCIPAL DEL MENU          //
////////////////////////////////////////////////////

void menuConf()
{
  //Serial.println("Entrando en menuConf");
  int menuPos=0;        //Variable que indica la posición en el switch-case
  int menuLista=0;      //Variable que nos indica la posicion en el menu
  char boton;           //Variable que almacena el valor devuelto por la funcion selectMenu()
  salir = false;        //Variable que nos mantiene en el menu

  delay(200);
  
  while (!salir)
  {
    switch (menuPos)
    {
      case 0:          //CONTROLA LOS BOTONES PARA AVANZAR EN LA LISTA Y PARA SELECCIONAR OPCION
      {
      updateMenu(menuLista);
      delay(200);
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 8, menuLista);
      if (boton == 'd')
      menuLista ++;
      else if (boton == 'u')
      menuLista --;
      else if (boton == 's')
      menuPos=menuLista+1;
      }break;

      case 1:          //CONFIGURAR HORA             
      {
      Serial.println(" menuConf - HORA RTC");
      horaRTC();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0;
      }break;

      case 2:          //CONFIGURAR MODOS FUNCIONAMIENTO
      {
      Serial.println(" menuConf - MODOS FUNCION");
      modoArranque();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0; 
      }break;
      
      case 3:          //CONFIGURAR HORARIOS
      {
      Serial.println(" menuConf - HORARIOS");
      configHorarios();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0;  
      }break;
      
      case 4:          //CONFIGURAR TIEMPOS ACTUADORES
      {
      Serial.println(" menuConf - TIEMPOS ACTUADOR");
      actuadores();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0; 
      }break;
      
      case 5:          //CONFIGURAR TEMPERATURAS
      {
      Serial.println(" menuConf - TEMPERATURAS");
      temperaturas ();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0;
      }break;
      
      case 6:          //REALIZAR TEST ACTUADORES
      {
      Serial.println(" menuConf - TEST");
      //APAGAR TODO AL SALIR !!!!!!!!!!!!!!!!!!!!!!!!
      test ();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0;
      }break;
      
      case 7:          //VER VALORES DE LOS SENSORES
      {
      Serial.println(" menuConf - SENSORES");
      sensores();
      updateMenu(menuLista);
      delay(300);
      menuPos = 0;
      }break;
      
      case 8:          //GUARDAR CAMBIOS Y SALIR
      {
      Serial.println(" menuConf - GUARDAR");
        for (int rept = 0; rept < 2; rept ++)
        {
        updateTitulo(9);
        delay(500);
        lcd.clear();
        delay(500);
        }
      writeConfig();
      salir = true;
      resetSistema();
      }break;

      case 9:          //SALIR SIN GUARDAR
      {
      Serial.println(" menuConf - SALIR");
        for (int rept = 0; rept < 2; rept ++)
        {
        updateTitulo(10);
        delay(500);
        lcd.clear();
        delay(500);
        }
      salir = true;
      resetSistema();
      }
    }
  }
}






///////////////////////////////////////////////////////////
//        MENU MODOS - DEFINE LA FORMA DE FUNCIONAR
///////////////////////////////////////////////////////////
// MODO ON: MANUAL - AUTO ----  encendido por horarios o solo manual
// TERMO: ON - OFF  ----  si hay termo, no permite enfriar al salir
// TIM/LLAM: INT/LLAMA - TIEMPO ---- control de alimentacion por intensidad de llama o tiempo
// SEG LLAM: ON - OFF ----  controlar que hay llama
// SALIR

void modoArranque()
{
  int modosLista = 0;           //Variable que almacena la posicion en este submenu
  int posModos = 1;             //Variable que almacena la posicion en el switch-case
  boolean salirModos = false;   //Variable que nos mantiene dentro de este submenu
  char boton;                   //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(1);              //Borra display y muestra el titulos MENU MODOS

  while (!salirModos)
  {
    switch (posModos)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 4, modosLista);
      
      if (boton == 'd')
      modosLista ++;
      else if (boton == 'u')
      modosLista --;
      else if (boton == 's')
      {
        if (modosLista == 0)
          {
          manual = !manual;
          delay(200);
          }
          if (modosLista == 1)
          {
          modoTermo = !modoTermo;
          delay(200);
          }
          if (modosLista == 2)
          {
          ctrLlama = !ctrLlama;
          delay(200);
          }
          if (modosLista == 3)
          {
          segLlama = !segLlama;
          delay(200);
          }
          if (modosLista == 4)
          {
          salirModos = true;
          }
        }
        posModos = modosLista+1;
      }break;

      
      case 1:
      {
      manual ? updateOpcion(11, -1, 12) : updateOpcion(11, -1, 13);
      posModos = 0;
      }break;

      case 2:
      {
      modoTermo ? updateOpcion(50, -1, 18) : updateOpcion(50, -1, 19); 
      posModos = 0; 
      }break;

      case 3:
      {
      ctrLlama ? updateOpcion(14, -1, 15) : updateOpcion(14, -1, 16);
      posModos = 0;
      }break;

      case 4:
      {
      segLlama ? updateOpcion(17, -1, 18) : updateOpcion(17, -1, 19); 
      posModos = 0; 
      }break;

      case 5:
      {
      updateOpcion(20, -1, 21);
      posModos = 0; 
      }break;
    }
  }
}




////////////////////////////////////////////////
//        SENSORES
///////////////////////////////////////////////
// VER TEMPERATURA CALDERA
// VER TEMPERATURA EXTERIOR
// VER TEMPERATURA VIVIENDA
// VER INTENSIDAD LLAMA
// VER VALOR PULSADORES 

void sensores()
{
  int sensorLista = 0;           //Variable que almacena la posicion en este submenu
  int posSensor = 1;             //Variable que almacena la posicion en el switch-case
  boolean salirSensor = false;   //Variable que nos mantiene dentro de este submenu
  boolean sensorMostrar = false; //Variable que mantiene mostrando la salida de un sensor
  char boton;                    //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(6);               //Borra display y muestra el titulo SENSORES

  while (!salirSensor)
  {
    switch (posSensor)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      if (!sensorMostrar)
      boton = selectMenu (0, 5, sensorLista);
      else
      {
        while((boton = read_LCD_buttons()) != 5)
        {
        Serial.print("Dentro ");
        Serial.print(sensorLista);
        lcd.setCursor(10,1);
        lcd.print(":     ");
        lcd.setCursor(12,1);
          if (sensorLista == 0)
          lcd.print(leerTempCald());
          //else if (sensorLista == 1)    //Muestra otras temperaturas si se habilita un sensor
          //leerTempExt();
          //else if (sensorLista == 2)
          //leerTempVivi();
          else if (sensorLista == 3)
          lcd.print(leerIntensLlama());
          else if (sensorLista == 4)
          lcd.print(analogRead(pulsadorLcd));
        delay(200);
        }
        sensorMostrar = false;
        delay(200);
      }
      
      if (boton == 'd')
      sensorLista ++;
      else if (boton == 'u')
      sensorLista --;
      else if (boton == 's')
      {
        if (sensorLista == 5)
          {
          salirSensor = true;
          }
        else if (sensorLista == 0 || sensorLista == 1 || sensorLista == 2 || sensorLista == 3 || sensorLista == 4)
          {
          sensorMostrar = true;
          }
          delay(200);
       }
      posSensor = sensorLista+1;
      delay(200);
      }break;
      
      case 1:             //Mostrar temperatura caldera
      {
      updateOpcion(22, -1, 21);
      posSensor = 0;
      }break;

      case 2:             //Mostrar temperatura exterior
      {
      updateOpcion(23, -1, 21);
      posSensor = 0;
      }break;

      case 3:             //Mostrar temperatura vivienda
      {
      updateOpcion(24, -1, 21);
      posSensor = 0; 
      }break;

      case 4:             //Mostrar valor llama
      {
      updateOpcion(25, -1, 21);
      posSensor = 0; 
      }break;

      case 5:             //Mostrar valor pulsadores
      {
      updateOpcion(51, -1, 21);
      posSensor = 0; 
      }break;

      case 6:             //Salir
      {
      updateOpcion(20, -1, 21);
      posSensor = 0; 
      }break;
    }
  }
}




////////////////////////////////////////////////
//        TEST
///////////////////////////////////////////////
// RESISTENCIA
// ACTUADOR RESISTENCIA
// HUSILLO PELLET
// VENTILADOR
// BOMBA AGUA

void test()
{
  int testLista = 0;           //Variable que almacena la posicion en este submenu
  int posTest = 1;             //Variable que almacena la posicion en el switch-case
  boolean salirTest = false;   //Variable que nos mantiene dentro de este submenu
  boolean testEstado = false;  //Variable para que indica el estado encendido/apagado
  char boton;                   //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(5);              //Borra display y muestra el titulo TEST

  while (!salirTest)
  {
    switch (posTest)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 5, testLista);

      if (boton == 'd')
      {
      testLista ++;
      testEstado = false;
      }
      else if (boton == 'u')
      {
      testLista --;
      testEstado = false;
      }
      else if (boton == 's')
      {
        if (testLista == 5)
        {
          apagTodo();         //Ponemos a nivel bajo todas las salidas antes de salir
          salirTest = true;
        }
        else
        testEstado = !testEstado;
      }
      posTest = testLista+1;
      delay(200);
      }break;
      
      case 1:       //Test resistencia
      {
      if (testEstado)
        {
        updateOpcion(26, -1, 18);
        digitalWrite(triacResis, HIGH);
        }
      else
        {
        updateOpcion(26, -1, 19);
        digitalWrite(triacResis, LOW);
        }
      posTest = 0;
      }break;

      case 2:       //Test actuador resistencia
      {
      if (testEstado)
        {
        updateOpcion(27, -1, 18);
        digitalWrite(releHusiRes1, LOW);
        delay(200);
        digitalWrite(releHusiRes2, HIGH);
        }
      else
        {
        updateOpcion(27, -1, 19);
        digitalWrite(releHusiRes1, HIGH);
        delay(200);
        digitalWrite(releHusiRes2, LOW);
        }
      posTest = 0;
      }break;

      case 3:        //Test husillo pellet
      {
      if (testEstado)
        {
        updateOpcion(28, -1, 18);
        digitalWrite(releHusiPel, LOW);
        }
      else
        {
        updateOpcion(28, -1, 19);
        digitalWrite(releHusiPel, HIGH);
        }
      posTest = 0;
      }break;

      case 4:        //Test ventilador
      {
      if (testEstado)
        {
        updateOpcion(29, -1, 18);
        digitalWrite(triacSopla, HIGH);
        }
      else
        {
        updateOpcion(29, -1, 19);
        digitalWrite(triacSopla, LOW);
        }
      posTest = 0;
      }break;

      case 5:        //Test bomba
      {
      if (testEstado)
        {
        updateOpcion(30, -1, 18);
        digitalWrite(triacBomb, HIGH);
        }
      else
        {
        updateOpcion(30, -1, 19);
        digitalWrite(triacBomb, LOW);
        }
      posTest = 0;
      }break;

      case 6:
      {
      updateOpcion(20, -1, 21);
      posTest = 0;
      }break;
    }
  }
}


 




////////////////////////////////////////////////
//        TEMPERATURAS
///////////////////////////////////////////////
// TEMPERATURA ARRANQUE BOMBA
// TEMPERATURA PARAR BOMBA
// TEMPERATURA ARRANQUE QUEMADOR
// TEMPERATURA PARAR QUEMADOR
// TEMPERATURA ERROR
// TEMPERATURA ENCENCER VIVIENDA
// TEMPERATURA APAGAR VIVIENDA

void temperaturas()
{
  int temperaturaLista = 0;           //Variable que almacena la posicion en este submenu
  int posTemperatura = 1;             //Variable que almacena la posicion en el switch-case
  boolean salirTemperatura = false;   //Variable que nos mantiene dentro de este submenu
  boolean cambioTemp = false;         //Variable que nos indica que queremos modificar la temperatura seleccionada
  char boton;                         //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(4);                    //Borra display y muestra el titulos MENU MODOS

  while (!salirTemperatura)
  {
    switch (posTemperatura)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 7, temperaturaLista);
      
      if (boton == 'd')
      temperaturaLista ++;
      else if (boton == 'u')
      temperaturaLista --;
      else if (boton == 's')
      {
        if (temperaturaLista == 7)
          salirTemperatura = true;
        else
          cambioTemp = true;
       }
        posTemperatura = temperaturaLista+1;
        delay(200);
      }break;
      
      
      case 1:       //Temperatura arranque bomba
      {
      updateOpcion(31, tempBombaMax, 38);   //Equivale a: lcd.setCursor(0,1); lcd.print("                "); lcd.setCursor(0,1);lcd.print ("ARRAN BOM: "); lcd.print (tempBombaMax); lcd.print (" C");
  
      if (cambioTemp)
        {
        tempBombaMax = mostrarCambioValor(80, 20, 11, tempBombaMax, "ARRAN BOM: ");
        lcd.print (" C"); 
        cambioTemp = false; 
        delay (500);
        }
      posTemperatura = 0;
      }break;

      case 2:       //Temperatura parada bomba
      {
      updateOpcion(32, tempBombaMin, 38);   //"PARAR BOM: "
      if (cambioTemp)
        {
        tempBombaMin = mostrarCambioValor(80, 20, 11, tempBombaMin, "PARAR BOM: ");
        lcd.print (" C"); 
        cambioTemp = false; 
        delay (500);
        }
      posTemperatura = 0;
      }break;

      case 3:       //Temperatura arranque quemador
      {
      updateOpcion(33, tempCalderaMin, 38);   //"ARRAN QUE: "
      if (cambioTemp)
        {
        tempCalderaMin = mostrarCambioValor(80, 20, 11, tempCalderaMin, "ARRAN QUE: ");
        lcd.print (" C"); 
        cambioTemp = false;
        delay (500);  
        }
      posTemperatura = 0;
      }break;

      case 4:       //Temperatura parada quemador
      {
      updateOpcion(34, tempCalderaMax, 38);   //"PARAR QUE: "
      if (cambioTemp)
        {
        tempCalderaMax = mostrarCambioValor(80, 20, 11, tempCalderaMax, "PARAR QUE: ");
        lcd.print (" C");
        cambioTemp = false; 
        delay (500);
        }
      posTemperatura = 0;
      }break;

      case 5:       //Temperatura maxima seguridad
      {
      updateOpcion(35, tempCalderaError, 38);   //"TEMP ERRO: " 
      if (cambioTemp)
        {
        tempCalderaError = mostrarCambioValor(100, 60, 11, tempCalderaError, "TEMP ERRO: ");
        lcd.print (" C");
        cambioTemp = false; 
        delay (500);
        }
      posTemperatura = 0;
      }break;

      case 6:       //Temperatura vivienda para arranque caldera
      {
      updateOpcion(36, tempViviendaMin, 38);   //"ENCE VIVI: " 
      if (cambioTemp)
        {
        tempViviendaMin = mostrarCambioValor(80, 20, 11, tempViviendaMin, "ENCE VIVI: ");
        lcd.print (" C");
        cambioTemp = false;
        delay (500);
        }  
      posTemperatura = 0;
      }break;

      case 7:       //Temperatura vivienda para apagar caldera
      {
      updateOpcion(37, tempViviendaMax, 38);   //"APAG VIVI: " 
      if (cambioTemp)
        {
        tempViviendaMax = mostrarCambioValor(80, 20, 11, tempViviendaMax, "APAG VIVI: ");
        lcd.print (" C");
        cambioTemp = false; 
        delay (500);
        }
      posTemperatura = 0;
      }break;

      case 8:
      {
      updateOpcion(20, -1, 21);
      posTemperatura = 0; 
      }break;
    }
  }
}



 

////////////////////////////////////////////////
//        ACTUADORES
///////////////////////////////////////////////
// TIEMPO PREBARRIDO
// TIEMPO RESISTENCIA
// TIEMPO RETARDO SOPLADOR
// TIEMPO CARGA PELLET INICIAL
// TIEMPO CARGA PELLET MANTENIMIENTO
// TIEMPO ESPERA ENTRE CARGA
// INTENSIDAD LLAMA MINIMA DETECCION FUEGO
// TIEMPO DE PAUSA MAXIMA SIN CARGAR PELLET
// TIEMPO LIMPIEZA FINAL

void actuadores()
{
  int actuadoresLista = 0;            //Variable que almacena la posicion en este submenu
  int posActuadores = 1;              //Variable que almacena la posicion en el switch-case
  boolean salirActuadores = false;    //Variable que nos mantiene dentro de este submenu
  boolean cambioActuadores = false;   //Variable que nos indica que queremos modificar la temperatura seleccionada
  char boton;                         //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(3);                    //Borra display y muestra el titulos MENU MODOS

  while (!salirActuadores)
  {
    switch (posActuadores)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 9, actuadoresLista);
      
      if (boton == 'd')
      actuadoresLista ++;
      else if (boton == 'u')
      actuadoresLista --;
      else if (boton == 's')
      {
        if (actuadoresLista == 9)
          salirActuadores = true;
        else
          cambioActuadores = true;
       }
        posActuadores = actuadoresLista+1;
        delay(200);
      }break;
      
      
      case 1:       //Definicion tiempo de prebarrido
      {
      updateOpcion(39, tPrebarrido, 48);   //"PREBARRI: " 
      if (cambioActuadores)
        {
        tPrebarrido = mostrarCambioValor(60, 0, 10, tPrebarrido, "PREBARRI: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 2:       //Definicion tiempo de resistencia
      {
      updateOpcion(40, tResistencia, 48);   //"RESISTEN: "
      if (cambioActuadores)
        {
        tResistencia = mostrarCambioValor(400, 0, 10, tResistencia, "RESISTEN: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 3:       //Definicion tiempo de resistencia+ventilador
      {
      updateOpcion(41, tVentiResis, 48);   //"RET SOPL: "
      if (cambioActuadores)
        {
        tVentiResis = mostrarCambioValor(tResistencia, 0, 10, tVentiResis, "RET SOPL: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 4:       //Definicion tiempo descarga pellet arranque
      {
      updateOpcion(42, tPelletIniS, 48);   //"RET SOPL: "
      if (cambioActuadores)
        {
        tPelletIniS = mostrarCambioValor(60, 0, 10, tPelletIniS, "PEL S IN: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 5:       //Definicion tiempo descargas pellet mantenimiento
      {
      updateOpcion(43, tPelletManS, 48);   //"PEL S MA: "
      if (cambioActuadores)
        {
        tPelletManS = mostrarCambioValor(60, 0, 10, tPelletManS, "PEL S MA: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 6:       //Definicion tiempo espera entre descargas pellet mantenimiento
      {
      updateOpcion(44, tPelletIntS, 48);   //"PEL PERI: "
      if (cambioActuadores)
        {
        tPelletIntS = mostrarCambioValor(120, 0, 10, tPelletIntS, "PEL PERI: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 7:       //Definicion nivel intensidad luminosa minimo descarga pellet mantenimiento
      {
      updateOpcion(45, tPelletIntL, 49);   //"PEL LLAM: "
      if (cambioActuadores)
        {
        tPelletIntL = mostrarCambioValor(100, 0, 10, tPelletIntL, "PEL LLAM: ");
        lcd.print (" L"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 8:       //Definicion tiempo máximo espera en modo pausa
      {
      updateOpcion(46, tPausaMax, 48);   //"PAUS MAX: "
      if (cambioActuadores)
        {
        tPausaMax = mostrarCambioValor(2000, 0, 10, tPausaMax, "PAUS MAX: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      
      case 9:       //Definicion tiempo máximo espera en modo pausa
      {
      updateOpcion(47, tLimpFinal, 48);   //"TIE LIMP: "
      if (cambioActuadores)
        {
        tLimpFinal = mostrarCambioValor(600, 0, 10, tLimpFinal, "TIE LIMP: ");
        lcd.print (" s"); 
        cambioActuadores = false; 
        delay (500);
        }
      posActuadores = 0;
      }break;

      case 10:
      {
      updateOpcion(20, -1, 21);
      posActuadores = 0; 
      }break;
    }
  }
}





////////////////////////////////////////////////
//        HORARIOS
///////////////////////////////////////////////
 
void configHorarios()
{
  int horariosLista = 0;           //Variable que almacena la posicion en este submenu
  int posHorarios = 1;             //Variable que almacena la posicion en el switch-case
  boolean salirHorarios = false;   //Variable que nos mantiene dentro de este submenu
  boolean cambioHorarios = false;  //Variable que nos indica que queremos modificar la temperatura seleccionada
  char boton;                      //Variable que almacena el valor devuelto por la funcion selectMenu()
  updateTitulo(2);                 //Borra display y muestra el titulos MENU MODOS

  while (!salirHorarios)
  {
    switch (posHorarios)
    {
      case 0:
      {
      //char selectMenu (int limInf, int limSup, int posList)
      boton = selectMenu (0, 4, horariosLista);
      
      if (boton == 'd')
      horariosLista ++;
      else if (boton == 'u')
      horariosLista --;
      else if (boton == 's')
      {
        if (horariosLista == 4)
          salirHorarios = true;
        else if (boton == 's')
          cambioHorarios = true;
       }
        posHorarios = horariosLista+1;
        delay(200);
      }break;
      
      
      case 1:       //Configuracion Horario 1
      {
      lcd.setCursor(8,0);
      lcd.print("1");
      MostrarHorarios(horaIni1, minutoIni1, horaFin1, minutoFin1, activo1);
      if (cambioHorarios)
      {
        delay(200);
        horaIni1 = mostrarCambioValor(23, 0, 10, horaIni1, "Hora Ini: ");
        delay(200);
        minutoIni1 = mostrarCambioValor(59, 0, 10, minutoIni1, "Minu Ini: ");
        delay(200);
        horaFin1 = mostrarCambioValor(23, 0, 10, horaFin1, "Hora Fin: ");
        delay(200);
        minutoFin1 = mostrarCambioValor(59, 0, 10, minutoFin1, "Minu Fin: ");
        delay(200);
        activarAlarma (0, activo1);
        delay(200); 
        MostrarHorarios(horaIni1, minutoIni1, horaFin1, minutoFin1, activo1);
        delay(200);
        cambioHorarios = false;
      }
      posHorarios = 0;
      }break;

      case 2:       //Configuracion Horario 2
      {
      lcd.setCursor(8,0);
      lcd.print("2");
      MostrarHorarios(horaIni2, minutoIni2, horaFin2, minutoFin2, activo2);
      if (cambioHorarios)
      {
        delay(200);
        horaIni2 = mostrarCambioValor(23, 0, 10, horaIni2, "Hora Ini: ");
        delay(200);
        minutoIni2 = mostrarCambioValor(59, 0, 10, minutoIni2, "Minu Ini: ");
        delay(200);
        horaFin2 = mostrarCambioValor(23, 0, 10, horaFin2, "Hora Fin: ");
        delay(200);
        minutoFin2 = mostrarCambioValor(59, 0, 10, minutoFin2, "Minu Fin: ");
        delay(200);
        activarAlarma (1, activo2);
        delay(200); 
        MostrarHorarios(horaIni2, minutoIni2, horaFin2, minutoFin2, activo2);
        delay(200); 
        cambioHorarios = false;
      }
      posHorarios = 0;
      }break;


      case 3:       //Configuracion Horario 3
      {
      lcd.setCursor(8,0);
      lcd.print("3");
      MostrarHorarios(horaIni3, minutoIni3, horaFin3, minutoFin3, activo3);
      if (cambioHorarios)
      {
        delay(200);
        horaIni3 = mostrarCambioValor(23, 0, 10, horaIni3, "Hora Ini: ");
        delay(200);
        minutoIni3 = mostrarCambioValor(59, 0, 10, minutoIni3, "Minu Ini: ");
        delay(200);
        horaFin3 = mostrarCambioValor(23, 0, 10, horaFin3, "Hora Fin: ");
        delay(200);
        minutoFin3 = mostrarCambioValor(59, 0, 10, minutoFin3, "Minu Fin: ");
        delay(200);
        activarAlarma (2, activo3);
        delay(200); 
        MostrarHorarios(horaIni3, minutoIni3, horaFin3, minutoFin3, activo3);
        delay(200); 
        cambioHorarios = false;
      }
      posHorarios = 0;
      }break;


      case 4:       //Configuracion Horario 4
      {
      lcd.setCursor(8,0);
      lcd.print("4");
      MostrarHorarios(horaIni4, minutoIni4, horaFin4, minutoFin4, activo4);
      if (cambioHorarios)
      {
        delay(200);
        horaIni4 = mostrarCambioValor(23, 0, 10, horaIni4, "Hora Ini: ");
        delay(200);
        minutoIni4 = mostrarCambioValor(59, 0, 10, minutoIni4, "Minu Ini: ");
        delay(200);
        horaFin4 = mostrarCambioValor(23, 0, 10, horaFin4, "Hora Fin: ");
        delay(200);
        minutoFin4 = mostrarCambioValor(59, 0, 10, minutoFin4, "Minu Fin: ");
        delay(200);
        activarAlarma (3, activo4);
        delay(200); 
        MostrarHorarios(horaIni4, minutoIni4, horaFin4, minutoFin4, activo4);
        delay(200); 
        cambioHorarios = false;
      }
      posHorarios = 0;
      }break;

      case 5:
      {
      updateOpcion(20, -1, 21);
      posHorarios = 0; 
      }break;
    }
  }
}







////////////////////////////////////////////////////
//    CAMBIAR HORA RTC
////////////////////////////////////////////////////

void horaRTC()
{
  now = rtc.now();        //Carga la hora actual en variables
  hora = now.hour();
  minuto = now.minute();
  segundo = now.second();
  dia = now.day();
  mes = now.month();
  ano = now.year();

  updateTitulo(0);        //Escribe el titulo de la funcion para saber en que submenu estamos

  delay(200);
  //int mostrarCambioValor(int maximo, int minimo, int lugar, int valor, String nombre)
  hora = mostrarCambioValor(23, 0, 6, hora, "Hora: ");
  delay(300);
  minuto = mostrarCambioValor(59, 0, 9, minuto, "Minutos: ");
  delay(300);
  segundo = mostrarCambioValor(59, 0, 10, segundo, "Segundos: ");
  delay(300);
  dia = mostrarCambioValor(31, 0, 5, dia, "Dia: ");
  delay(300);
  mes = mostrarCambioValor(12, 0, 5, mes, "Mes: ");
  delay(300);
  ano = mostrarCambioValor(2050, 2000, 5, ano, "Ano: ");
  delay(300);
  
  rtc.adjust(DateTime(ano, mes, dia, hora, minuto, segundo));   //Actualizamos el rtc con los nuevos valores
}  
    
 
    
